package tests;

import static org.junit.Assert.*;

import org.junit.Test;

import implementation.Counter;

public class TestCounter2 {

	// Principle: group relevant assertions into a single
	// test method.
	@Test
	public void testOneIncrement() {
		// Test case where we increment the counter
		// once, and see if the actual value becomes 1.
		assertTrue(Counter.value == 0);
		Counter.increment();
		assertTrue(Counter.value == 1);
	}
	
	@Test
	public void testDecFromZero() {
		/* It's important to reset the static attributes to their initial values */
		Counter.value = Counter.MIN_COUNTER_VALUE;
		
		try {
			// Executing the method call below, we expect an IAE to occur.
			Counter.decrement();
			// If we are able to reach this line, that means the
			// expected IAE did not occur. 
			fail("The expected IAE did not occur");
		}
		catch (IllegalArgumentException e) {
			// If we reach this branch, that means 
			// the IAE occur from L29. This is expected,
			// so no assertion failure.
		}
	}

}








